<!-- forms\admin_framework\admin_sub_buttonbar_panel.jsp -->
<%@ taglib prefix="change" uri="http://www.telelogic.com/change" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>

<html>
	<head>
		<title></title>
		
		<style TYPE="text/css">
			<change:wsletExpander>
				<!-- WSLET CODE=PTInclude -->
				<!-- PARAM NAME=styles/subbuttonbar.css -->
				<!-- /WSLET -->
			</change:wsletExpander>
				
			<change:wsletExpander>
				<!-- WSLET CODE=PTInclude -->
				<!-- PARAM NAME=styles/tabs.css -->
				<!-- /WSLET -->
 			</change:wsletExpander>
 			
			div#tabs
			{
				position: absolute;
				bottom: 0;
				width: 100%;
			}
			
			#helpContainer
			{
				position: absolute;
				top: 6px;
				right: 10px;
			}
		</style>

		<script TYPE="text/javascript">
			<change:wsletExpander>
				<!-- WSLET CODE=PTLoadData -->
				<!-- PARAM NAME=CCM_SECURITY_DATA -->
				<!-- PARAM NAME=CCM_TOKEN -->
				<!-- PARAM NAME=CCM_ROLE -->
				<!-- PARAM NAME=CCM_TIMESTAMP -->
				<!-- PARAM NAME=CCM_USER -->
				<!-- PARAM NAME=CCM_VERSION VALUE="4.0" -->
				<!-- /WSLET -->
			</change:wsletExpander>	
				
			<change:wsletExpander>	
				<!-- WSLET CODE=PTInclude -->
				<!-- PARAM NAME=subhelp.js -->
				<!-- PARAM NAME=formload.js -->
				<!-- PARAM NAME=ptalert.js -->
				<!-- PARAM NAME=busy_blank.js -->
				<!-- PARAM NAME=waitwindow.js -->
				<!-- /WSLET -->
			</change:wsletExpander>
			
			var iValue = -1;
			
			function subbuttonbarLoad()
			{
				parent.parent.panel.EditAdmin = true;
				SetFormLoading(false);
				
				<c:choose>
					<c:when test="${isRemoteServer}">
						setView(5);
					</c:when>
					<c:otherwise>
						setView(0);
					</c:otherwise>
				</c:choose>
			}
			
			function unsetView()
			{
				iValue = -1;
			}
			
			function setView(iVal)
			{
				if (IsFormLoadingSilent())
				{	
					return;
				}
				
				adminMenuChangeFocus(iVal);
			}
			
			function adminMenuChangeFocus(iVal)
			{
				if (IsFormLoadingSilent())
				{
					return;
				}
			
				if (hasModifications() && !confirm("<change:resource key='err00074'/>"))
				{
					return;
				}
			
				parent.pt_status.location = "<change:urlCreator webResource='PTWEB'/>?ACTION_FLAG=tokenless_form&TEMPLATE_FLAG=LineStatus";
				iValue = iVal;
			
				switch(iVal)
				{
					case 0:
						focusTab("generalTab");
						window.document.changeFormLoader.TEMPLATE_FLAG.value = "Admin";
						window.document.changeFormLoader.ACTION_FLAG.value = "admin_form";
					break;
					case 1:
						focusTab("usersTab");
						window.document.changeFormLoader.TEMPLATE_FLAG.value = "AdminUserFrameset";
						window.document.changeFormLoader.ACTION_FLAG.value = "frameset_form";
					break;
					case 2:
						focusTab("listboxManagerTab");
						openWaitWindow("<change:resource key='loadingListboxDataMessage'/>");
						window.document.changeFormLoader.TEMPLATE_FLAG.value = "AdminCustomCfgFrameset";
						window.document.changeFormLoader.ACTION_FLAG.value = "frameset_form";
					break;
					case 3:
						focusTab("packageInstallerTab");
						packagesOnclick();
					return;
					case 5:
						focusTab("serverTab");
						<c:if test="${isStandAloneServer}">
							window.document.changeFormLoader.TEMPLATE_FLAG.value = "TransServerView";
							window.document.changeFormLoader.ACTION_FLAG.value = "frameset_form";
							break;
						</c:if>						
						<c:if test="${!isStandAloneServer}">
							serverTabOnclick();
							return;
						</c:if>					
					case 6:
						focusTab("securityTab");
						window.document.changeFormLoader.TEMPLATE_FLAG.value = "AclManager";
						window.document.changeFormLoader.ACTION_FLAG.value = "admin_form";
					break;
					case 7:
						focusTab("groupsTab");
						window.document.changeFormLoader.TEMPLATE_FLAG.value = "GroupManager";
						window.document.changeFormLoader.ACTION_FLAG.value = "admin_form";
					break;
					case 8:
						focusTab("searchTab");
						searchTabOnclick();
					return;
					case 9:
						focusTab("crSyncTab");
						crSyncTabOnclick();
					return;
				}
			
				window.document.changeFormLoader.method = "POST";
				window.document.changeFormLoader.action = "<change:urlCreator webResource='PTWEB'/>";
				window.document.changeFormLoader.target = "workspace";
				window.document.changeFormLoader.role.value = role;
				window.document.changeFormLoader.token.value = token;
				
				window.document.changeFormLoader.submit();
			}
			
			function hasModifications()
			{
				switch(iValue)
				{
					case 0: // General
						<c:if test="${!isRemoteServer}">
							return parent.workspace.hasModifications();
						</c:if>
						break;
					case 2: // Listbox Values
						return parent.workspace.listbox_cus_dataframe.hasModifications();
					case 3: // Package Installation
						break;
					case 5: // Server
						<c:if test="${isStandAloneServer}">
							return parent.workspace.hasModifications();
						</c:if>
						<c:if test="${!isStandAloneServer}">
							return parent.workspace.propertiesFrame.hasModifications();
						</c:if>
					case 1:  // User
					case 6: // ACLs
					case 7: // Groups
						return parent.workspace.hasModifications
							&& parent.workspace.hasModifications();
					case 8: // Search
						return parent.workspace.hasModifications
							&& parent.workspace.hasModifications();
					case 9: // CRs Syncing
						return parent.workspace.hasModifications
							&& parent.workspace.hasModifications();
				}
			
				return false;
			}
			
			function packagesOnclick()
			{
				window.document.changeFormLoader.method = "POST";
				window.document.changeFormLoader.action = "<change:urlCreator webResource='WSUPDATE'/>";
				window.document.changeFormLoader.target = "workspace";
				window.document.changeFormLoader.ACTION_FLAG.value = "package_form";
				window.document.changeFormLoader.role.value = role;
				window.document.changeFormLoader.token.value = token;
				
				window.document.changeFormLoader.submit();
			}
			
			
			/**
			 * Loads server main frame
			 */
			function serverTabOnclick()
			{
				window.document.serverMainFormLoader.token.value = token;
				window.document.serverMainFormLoader.role.value = role;
				
				window.document.serverMainFormLoader.submit();
			}
			
			function searchTabOnclick()
			{
				window.document.searchFormLoader.token.value = token;
				window.document.searchFormLoader.submit();
			}
			
			function crSyncTabOnclick()
			{
				window.document.adminFormLoader.formName.value = "adminCRSyncMain";
				window.document.adminFormLoader.submit();
			}
			
			function openUserHelp()
			{
				switch (iValue)
				{
					case 0:
						openHelp(role, 22); // General
					break;
					case 1:
						openHelp(role, 23); // User
					break;
					case 2:
						openHelp(role, 24); // Listbox Values
					break;
					case 3:
						openHelp(role, 25); // Package Installation
					break;
					case 5:
						openHelp(role, 28); // Server
					break;
					case 6:
						openHelp(role, 33); // ACLs
					break;
					case 7:
						openHelp(role, 32); // Groups
					break;
					case 8:
						openHelp(role, 41); // Search
					break;
					case 9:
						openHelp(role, 42); // Ghost CRs
					break;
				}
			}
			
			function focusTab(tabName)
			{
				var li = document.getElementById(tabName).parentNode;
				var siblings = li.parentNode.getElementsByTagName("li");
			
				for (var i = 0; i < siblings.length; i++)
				{
					var sibling = siblings[i];
					sibling.getElementsByTagName("a")[0].className = (sibling == li)
						? "current" 
						: "";
				}
			}
		</script>
	</head>
	
	<body onload="subbuttonbarLoad();">
		<table class="fullScreen">
			<tr>
				<th>
					<change:resource key='lbl01087'/>
				</th>
			</tr>
		</table>
	
		<div id="tabs">
			<ul class="tabbedList">
				<c:if test="${!isRemoteServer}">
					<li><a id="generalTab" href="javascript: adminMenuChangeFocus(0);" class="current"><change:resource key='lbl01080'/></a></li>
				</c:if>
				<li><a id="serverTab" href="javascript: adminMenuChangeFocus(5);"><change:resource key='lbl01081'/></a></li>
								
				<c:if test="${!isRemoteServer}">
					<li><a id="usersTab" href="javascript: adminMenuChangeFocus(1);"><change:resource key='lbl00160'/></a></li>
					<li><a id="groupsTab" href="javascript: adminMenuChangeFocus(7);"><change:resource key='groupsTab'/></a></li>
					<li><a id="securityTab" href="javascript: adminMenuChangeFocus(6);"><change:resource key='securityTab'/></a></li>
					<li><a id="searchTab" href="javascript: adminMenuChangeFocus(8);"><change:resource key='searchTab'/></a></li>
					
					<c:if test="${!isStandAloneServer}">
						<li><a id="crSyncTab" href="javascript: adminMenuChangeFocus(9);"><change:resource key='crSyncTab'/></a></li>
					</c:if>
					
					<li><a id="listboxManagerTab" href="javascript: adminMenuChangeFocus(2);"><change:resource key='lbl01082'/></a></li>
				</c:if>
				
				
				<li><a id="packageInstallerTab" href="javascript: adminMenuChangeFocus(3);"><change:resource key='lbl01083'/></a></li>
			</ul>
		</div>
	
		<div id="helpContainer">
			<a href="javascript: openUserHelp();" title="<change:resource key='alt00187'/>"><change:resource key='lbl01070'/></a>
		</div>
		
		<form name="changeFormLoader" action="NO_ACTION" class="hiddenForm">
			<input name="ACTION_FLAG" type="hidden" value="NO_ACTION">
			<input name="TEMPLATE_FLAG" type="hidden" value="NO_ACTION">
			
			<!-- Change Security Data -->
			<input name="role" type="hidden" value="NO_ACTION">
			<input name="token" type="hidden" value="NO_ACTION">
			<input name="formName" type="hidden" value="adminServerTab">
		</form>
		
		<form name="searchFormLoader" action="formLoadRestrictions.do" class="hiddenForm" method="POST" target="workspace">
			<input name="token" type="hidden">
			<input name="formName" type="hidden" value="adminSearchMain">
			<input name="crProcessRequired" type="hidden" value="true">
			<input name="searchMgrRequired" type="hidden" value="true">
		</form>
		
		<form name="adminFormLoader" action="adminFormLoader.do" class="hiddenForm" method="POST" target="workspace">
			<input name="token" type="hidden" value="${user.token}"}>
			<input name="formName" type="hidden">
			<input name="crProcessRequired" type="hidden" value="true">			
		</form>
		
		<form name="serverMainFormLoader" action="subButtonBarPanel.do" class="hiddenForm" method="POST" target="workspace">
			<input type="hidden" name="token">
			<input type="hidden" name="role">
			<input type="hidden" name="formName" value="serverMainForm">
			<input type="hidden" name="methodToCall" value="subButtonbarAction"> 
		</form>
	</body>
</html>
