<!-- %full_filespec: quick_search_results.jsp,6:ascii:W#2 % -->
<%@ taglib uri="/WEB-INF/struts-html.tld" prefix="html"%>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@ taglib prefix="change" uri="http://www.telelogic.com/change"%>

<c:if test="${empty foundCrs and empty recentCrs}">
	<h1 class="first">
		<change:resource key="lbl00096"/>
	</h1>
	<p class="first">
		<change:resource bundle="52_patch" key="noQuickSearchResults"/>
	</p>
</c:if>

<c:if test="${not empty foundCrs}">
	
	<h1 class="first">
		
		<%-- The previous/next links if necessary. Only shown if there is a another page of results. --%>
		<c:if test="${not empty next or not empty previous}">
			<div class="prev-next">
				<c:out value="${pageMessage}"/> &nbsp;
				
				<c:choose>
					<c:when test="${not empty previous}">
						<a href="#previous" previous="${previous}">
							&lt; <change:resource bundle="52_patch" key="previous"/>
						</a>
					</c:when>
					<c:otherwise>
						&lt; <change:resource bundle="52_patch" key="previous"/>
					</c:otherwise>
				</c:choose>

				&nbsp; | &nbsp;
				
				<c:choose>
					<c:when test="${not empty next}">
						<a href="#next" next="${next}">
							<change:resource bundle="52_patch" key="next"/> &gt;
						</a>
					</c:when>
					<c:otherwise>
						<change:resource bundle="52_patch" key="next"/> &gt;
					</c:otherwise>
				</c:choose>
			</div>
		</c:if>

		<change:resource key="lbl00096"/>
	</h1>

	<ul>
		<c:forEach var="cr" items="${foundCrs}" varStatus="status">
			<li <c:if test="${status.first}"> class="first"</c:if>
				crid="<c:out value="${cr.crid}"/>"
				synopsis="<c:out value="${cr.synopsis}"/>"
				>
				<c:out value="${cr.label}"/>
			</li>
		</c:forEach>
	</ul>

</c:if>

<c:if test="${not empty recentCrs}">
	<h1 <c:if test="${empty foundCrs}">class="first"</c:if> >
		<change:resource bundle="52_patch" key="recentCrs"/>
	</h1>
	<ul>
		<c:forEach var="cr" items="${recentCrs}" varStatus="status">
			<li <c:if test="${status.first}"> class="first"</c:if>
				crid="<c:out value="${cr.crid}"/>"
				synopsis="<c:out value="${cr.synopsis}"/>"
				>
				<c:out value="${cr.label}"/>
			</li>
		</c:forEach>
	</ul>
</c:if>
