<!-- forms\block_message.jsp -->
<%@ page isErrorPage="true" %>
<%@ taglib prefix="change" uri="http://www.telelogic.com/change" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>

<html>
<head>
	<title><change:resource key="productName" /></title>
	
	<style type="text/css">

<change:wsletExpander>
	<!-- WSLET CODE=PTInclude -->
	<!-- PARAM NAME=styles/default_admin.css -->
	<!-- /WSLET -->
</change:wsletExpander>

HTML, BODY
{
	padding: 0;
	margin: 0;
}

	</style>
	
	<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dojo/dojo/dojo.js" djConfig="parseOnLoad: true"></script>
	
	<script type="text/javascript">

var timerID = null;

function init()
{
	startClock();
}

function stopClock()
{
	clearTimeout(timerID);
	
	if (${param.isErrorMessage})
	{
		return;
	}

	document.getElementById("statusInfo").display = "none";
}

function startClock()
{	
	timerID = setTimeout("stopClock()", 300000);
}

function hasModifications() 
{
	return false;
}
	
dojo.addOnLoad(init);
	</script>
	
</head>

<body class="tundra">
	<div id="statusInfo" style="height: 100%; width: 100%; border-top: 1px solid #7183A1;"/>
	<table height="100%">
	<tr align="center">
		<td align="left" valign="center">
			<c:choose>
				<c:when test="${param.isErrorMessage}">
					<img src='<change:urlCreator webResource='PTIMAGES'/>ws_erroricon_sm.gif'>
				</c:when>
				<c:otherwise>
					<img src='<change:urlCreator webResource='PTIMAGES'/>ws_successicon_sm.gif'>					
				</c:otherwise>
			</c:choose>	
			<c:choose>
				<c:when test="${fn:length(param.message) > 100}">
					${fn:substring(param.message,0,100)}... 
					<button type="button" title="<change:resource key='java0114'/>" onclick="alert('${param.message}')">
						<change:resource key="more"/>
					</button>
				</c:when>
				<c:otherwise>
					${param.message}
				</c:otherwise>
			</c:choose>
		</td>
	</tr>
	</table>
</body>

</html>