<!-- forms\user_framework\admin_assign_default_home_pages.jsp -->
<%@ taglib prefix="change" uri="http://www.telelogic.com/change" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>

<html>
<head>
	<title></title>
	
	<style type="text/css">

<change:wsletExpander>
	<!-- WSLET CODE=PTInclude -->
	<!-- PARAM NAME=styles/default.css -->
	<!-- PARAM NAME=styles/note.css -->
	<!-- /WSLET -->
</change:wsletExpander>

<change:wsletExpander>
	<!-- WSLET CODE=PTInclude -->
	<!-- PARAM NAME=styles/tabs.css -->
	<!-- /WSLET -->
</change:wsletExpander>

<change:wsletExpander>
	<!-- WSLET CODE=PTInclude -->
	<!-- PARAM NAME=styles/bordered_tabs.css -->
	<!-- /WSLET -->
</change:wsletExpander>

<change:wsletExpander>
	<!-- WSLET CODE=PTInclude -->
	<!-- PARAM NAME=styles/available_users_groups.css -->
	<!-- /WSLET -->
</change:wsletExpander>

<change:wsletExpander>
	<!-- WSLET CODE=PTInclude -->
	<!-- PARAM NAME=styles/editableComboBox.css -->
	<!-- /WSLET -->
</change:wsletExpander>

table
{
	width: 100%;
}

table.homePages 
{
	width: 100%; /*100% of container produces horiz. scroll in Mozilla*/
}

table.homePages thead td	
{
	background: #B2BBCF;
	position:relative;
	border-bottom: 1px solid black;
	padding-left: 5px;
	padding-top: 2px;
	top: expression(document.getElementById("data").scrollTop-2); /*IE5+ only*/
}

table.homePages td
{
	padding-left: 5px;
	border-bottom: 1px solid black;
}

table.homePages>tbody	
{  /* child selector syntax which IE6 and older do not support*/
	overflow: auto; 
	height: 280px; /* 20px less than tableContainer */
	overflow-x: hidden;
}

div.tableContainer 
{
	width: 100%;		/* table width will be 99% of this*/
	height: 300px; 	/* must be greater than tbody*/
	overflow: auto;
	margin: 0 auto;
	border: 1px solid black;
}

.centered
{
	text-align: center;
}

#group-search-results, #user-search-results
{
	height: 218px;
}

#group-all-results, #user-all-results, #user-assigned-results, #group-assigned-results
{
	height: 255px;
}

#group-content, #user-content, #user-assigned-content, #group-assigned-content
{
	height: 263px;
}

	</style>
	<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dwr/engine.js"></script>
	<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dwr/util.js"></script>
	<script type="text/javascript" src="<change:urlCreator webResource='BASEURL'/>/dwr/interface/LdapGroupUtilsAjax.js"></script>
	<script type="text/javascript" src="<change:urlCreator webResource='BASEURL'/>/dwr/interface/LdapUserUtilsAjax.js"></script>
	<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dojo/dojo/dojo.js" djConfig="parseOnLoad: true"></script>
	
	<script type="text/javascript">

var isModified = false;

var token = "${user.token}";
//Global variable for Copy/Paste Settings
var settings;
var currentlySelected = new Array();
var currentlySelectedTextValues = new Array();
var firstMultiSelectOperation = false;

var allHomePages = new Array();
<c:forEach items="${homePages.homePages}" var="homePage" varStatus="status">
	allHomePages[${status.index}] = <change:javaScriptEscape value="${homePage.name}"/>;
</c:forEach>

var homePageAssignments = new Object();
homePageAssignments.users = new Array();

<c:forEach var="assignment" items="${assignments.userAssignments}" varStatus="status">
	homePageAssignments.users[${status.index}] = new Object();
	homePageAssignments.users[${status.index}].name = <change:javaScriptEscape value="${assignment.name}"/>;
	homePageAssignments.users[${status.index}].displayName = <change:javaScriptEscape value="${assignment.userDisplayName}"/>;
	homePageAssignments.users[${status.index}].defaultHomePage = <change:javaScriptEscape value="${assignment.defaultHomePage}"/>;
	homePageAssignments.users[${status.index}].dirty = false;
	homePageAssignments.users[${status.index}].homePages = new Array();
	
	<c:forEach var="userHomePage" items="${assignment.homePages}" varStatus="innerStatus">
		homePageAssignments.users[${status.index}].homePages[${innerStatus.index}] = <change:javaScriptEscape value="${userHomePage}"/>;
	</c:forEach>
</c:forEach>

homePageAssignments.groups = new Array();

<c:forEach var="assignment" items="${assignments.groupAssignments}" varStatus="status">
	homePageAssignments.groups[${status.index}] = new Object();
	homePageAssignments.groups[${status.index}].name = <change:javaScriptEscape value="${assignment.name}"/>;
	homePageAssignments.groups[${status.index}].displayName = <change:javaScriptEscape value="${assignment.name}"/>;
	homePageAssignments.groups[${status.index}].defaultHomePage = <change:javaScriptEscape value="${assignment.defaultHomePage}"/>;
	homePageAssignments.groups[${status.index}].dirty = false;
	homePageAssignments.groups[${status.index}].homePages = new Array();
	
	<c:forEach var="groupHomePage" items="${assignment.homePages}" varStatus="innerStatus">
		homePageAssignments.groups[${status.index}].homePages[${innerStatus.index}] = <change:javaScriptEscape value="${groupHomePage}"/>;
	</c:forEach>
</c:forEach>

<change:wsletExpander>
<!-- WSLET CODE=PTInclude -->
<!-- PARAM NAME=Arrays.js -->
<!-- /WSLET -->
</change:wsletExpander>

<change:wsletExpander>
<!-- WSLET CODE=PTInclude -->
<!-- PARAM NAME=EventUtils.js -->
<!-- /WSLET -->
</change:wsletExpander>

<change:wsletExpander>
<!-- WSLET CODE=PTInclude -->
<!-- PARAM NAME=StyleUtils.js -->
<!-- /WSLET -->
</change:wsletExpander>

<change:wsletExpander>
<!-- WSLET CODE=PTInclude -->
<!-- PARAM NAME=SelectUtils.js -->
<!-- /WSLET -->
</change:wsletExpander>

<change:wsletExpander>
<!-- WSLET CODE=PTInclude -->
<!-- PARAM NAME=MessageFormat.js -->
<!-- /WSLET -->
</change:wsletExpander>

<change:wsletExpander>
<!-- WSLET CODE=PTInclude -->
<!-- PARAM NAME=domUtilities.js -->
<!-- /WSLET -->
</change:wsletExpander>

<change:wsletExpander>
<!-- WSLET CODE=PTInclude -->
<!-- PARAM NAME=TabUtils.js -->
<!-- /WSLET -->
</change:wsletExpander>

<change:wsletExpander>
<!-- WSLET CODE=PTInclude -->
<!-- PARAM NAME=DwrCleanUp.js -->
<!-- /WSLET -->
</change:wsletExpander>

<change:wsletExpander>
<!-- WSLET CODE=PTInclude -->
<!-- PARAM NAME=AvailableGroups.js -->
<!-- /WSLET -->
</change:wsletExpander>

<change:wsletExpander>
<!-- WSLET CODE=PTInclude -->
<!-- PARAM NAME=AvailableUsers.js -->
<!-- /WSLET -->
</change:wsletExpander>

<change:wsletExpander>
	<!-- WSLET CODE=PTInclude -->
	<!-- PARAM NAME=subhelp.js -->
	<!-- PARAM NAME=emphasis.js -->
	<!-- /WSLET -->
</change:wsletExpander>

<change:wsletExpander>
	<!-- WSLET CODE=PTDataListBox -->
	<!-- PARAM NAME=CCM_LISTBOX VALUE=CCM_ROLES -->		
	<!-- PARAM NAME=JAVASCRIPT_IDENTIFIER VALUE=CCM_ROLES -->
	<!-- /WSLET -->
</change:wsletExpander>
	
<change:wsletExpander>
	<!-- WSLET CODE=PTAdmin -->
	<!-- PARAM NAME=DATABASE_DATA -->
	<!-- PARAM NAME=DISABLE_NON_ADMINS -->
	<!-- /WSLET -->
</change:wsletExpander>

<change:wsletExpander>
	<!-- WSLET CODE=PTInclude -->
	<!-- PARAM NAME=editableComboBox.js -->
	<!-- /WSLET -->
</change:wsletExpander>	
	
<change:wsletExpander>
	<!-- WSLET CODE=PTInclude -->
	<!-- PARAM NAME=findObjectPositionUtils.js -->
	<!-- /WSLET -->
</change:wsletExpander>

<change:wsletExpander>
	<!-- WSLET CODE=PTInclude -->
	<!-- PARAM NAME=fragmentUtils.js -->
	<!-- /WSLET -->
</change:wsletExpander>

function markUnSaved()
{
	var button = dojo.byId("saveButton");
	emphasizeButton(button);
	
	window.isModified = true;
}

function hasModifications()
{
	return window.isModified;
}

function verifySelection()
{
	if (currentlySelected.length == 0)
	{
		alert("<change:resource key="selectUserGroupFirst"/>");
		return false;
	}
	
	return true;
}

function selectAllOnClick()
{
	if (!verifySelection())
	{
		return;
	}

	var checkboxes = document.selectHomePages.visibleBoxes;
	var length = checkboxes.length;
	var foundChecked = false;
	
	if (length == undefined)
	{
		checkboxes.checked = true;
		addHomePageToSelected(eval(checkboxes.value), false);
		var radio = document.getElementById("defaultRadio_0");
		radio.disabled = false;
		radio.checked = true;
		markHomePageAsDefaultForSelected(eval(checkboxes.value));
		return;
	}
	else
	{
		for (var i = 0; i < length; i++)
		{
			checkboxes[i].checked = true;
			
			var radio = document.getElementById("defaultRadio_" + i);
			radio.disabled = false;
			
			if (radio.checked)
			{
				foundChecked = true;
			}
			
			addHomePageToSelected(eval(checkboxes[i].value), false);
		}
	}
	
	if (!foundChecked)
	{
		var radio = document.getElementById("defaultRadio_0");
		radio.checked = true;
		markHomePageAsDefaultForSelected(eval(checkboxes[0].value));
	}
}

function clearAllOnClick(forSelectedUsers)
{
	if ((forSelectedUsers) && (!verifySelection()))
	{
			return;
	}
	
	var checkboxes = document.selectHomePages.visibleBoxes;
	var length = checkboxes.length;
	
	if (length == undefined)
	{
		checkboxes.checked = false;
		var radio = document.getElementById("defaultRadio_0");
		radio.disabled = true;
		radio.checked = false;
		
		if (forSelectedUsers)
		{
			removeHomePageFromSelected(eval(checkboxes.value));
		}	
	}
	else
	{
		for (var i = 0; i < length; i++)
		{
			checkboxes[i].checked = false;
			
			var radio = document.getElementById("defaultRadio_" + i);
			radio.disabled = true;
			radio.checked = false;
			
			if (forSelectedUsers)
			{
				removeHomePageFromSelected(eval(checkboxes[i].value));
			}
		}
	}
	
	if (forSelectedUsers)
	{
		clearSelectedUsersHomePages();
	}
}

function copySettingsOnClick()
{
	if (!verifySelection())
	{
		return;
	}
	
	//uses global variable settings
	window.settings = new Object();
	window.settings.homePages = new Array();
	
	var checkboxes = document.selectHomePages.visibleBoxes;
	var length = checkboxes.length;
	
	if (length == undefined)
	{
		if (checkboxes.checked)
		{
			window.settings.homePages[window.settings.homePages.length] = eval(checkboxes.value);
			
			var radio = document.getElementById("defaultRadio_0");
				
			if (radio.checked)
			{
				window.settings.defaultHomePage = eval(checkboxes.value);
			}
		}
	}
	else
	{
		for (var i = 0; i < length; i++)
		{
			if (checkboxes[i].checked)
			{
				window.settings.homePages[window.settings.homePages.length] = eval(checkboxes[i].value);
				
				var radio = document.getElementById("defaultRadio_" + i);
				
				if (radio.checked)
				{
					window.settings.defaultHomePage = eval(checkboxes[i].value);
				}
			}
		}
	}
	
	enablePasteSettings();
}

function pasteSettingsOnClick()
{
	if (!verifySelection())
	{
		return;
	}
	
	//uses global variable settings
	clearAllOnClick(true);
	
	var checkboxes = document.selectHomePages.visibleBoxes;
	var length = checkboxes.length;
	
	if (length == undefined)
	{
		if (Arrays.contains(window.settings.homePages, eval(checkboxes.value)))
		{
			checkboxes.checked = true;
			
			var radio = document.getElementById("defaultRadio_0");
			radio.disabled = false;
			
			if (eval(checkboxes.value) == window.settings.defaultHomePage)
			{				
				radio.checked = true;	
			}
			
			addHomePageToSelected(eval(checkboxes.value), radio.checked);
		}
	}
	else
	{
		for (var i = 0; i < length; i++)
		{		
			if (Arrays.contains(window.settings.homePages, eval(checkboxes[i].value)))
			{
				checkboxes[i].checked = true;
				
				var radio = document.getElementById("defaultRadio_" + i);
				radio.disabled = false;
				
				if (eval(checkboxes[i].value) == window.settings.defaultHomePage)
				{				
					radio.checked = true;	
				}
				
				addHomePageToSelected(eval(checkboxes[i].value), radio.checked);
			}	
		}
	}
}

function visibleOnClick(checkbox, index)
{
	if (!verifySelection())
	{
		checkbox.checked = false;
		return;
	}
	
	var radio = document.getElementById("defaultRadio_" + index);
	
	if (checkbox.checked)
	{	
		radio.disabled = false;
		
		var radios = document.selectHomePages.defaultHomePages;
		var foundChecked = false;
		
		for (var i = 0; i < radios.length; i++)
		{
			if (radios[i].checked)
			{
				foundChecked = true;
				break;
			}
		}
		
		if (!foundChecked)
		{
			radio.checked = true;
		}
		
		addHomePageToSelected(eval(checkbox.value), radio.checked);
	}
	else
	{
		radio.disabled = true;
		radio.checked = false;
		removeHomePageFromSelected(eval(checkbox.value));
	}
}

function sortByOnChange(sortBy)
{
	clearAllOnClick(false);
	
	if (sortBy.options[sortBy.selectedIndex].value == "users")
	{
		document.getElementById("usersDiv").style.display = "";
		document.getElementById("groupsDiv").style.display = "none";
		userChanged();
	}
	else
	{
		document.getElementById("groupsDiv").style.display = "";
		document.getElementById("usersDiv").style.display = "none";
		
		if (AvailableGroups.select == null)
		{
			if (isFilterTab)
			{
				AvailableGroups.showSearch();
			}
			else
			{
				AvailableGroups.showAll();
			}
		}
		
		groupChanged();
	}
}

function saveOnClick()
{
	var changeSet = new Object();
	changeSet.users = new Array();
	changeSet.groups = new Array();
	
	var list = homePageAssignments.users;
	
	for (var i = 0; i < list.length; i++)
	{
		if (list[i].dirty)
		{		
			changeSet.users[changeSet.users.length] = list[i];
		}
	}
	
	list = homePageAssignments.groups;
	
	for (var i = 0; i < list.length; i++)
	{
		if (list[i].dirty)
		{
			changeSet.groups[changeSet.groups.length] = list[i];
		}
	}
	
	window.document.saveHomePageAssignments.assignmentsAsJSON.value = dojo.toJson(changeSet);
	window.document.saveHomePageAssignments.submit();
}

function validateAssignments(list)
{		
	for (var i = 0; i < list.length; i++)
	{
		var elementsToRemove = new Array();
		
		for (var j = 0; j < list[i].homePages.length; j++)
		{
			var homePage = list[i].homePages[j];
						
			if (!validHomePage(homePage))
			{
				elementsToRemove[elementsToRemove.length] = j;
				list[i].dirty = true;
								
				if (homePage == list[i].defaultHomePage)
				{
					list[i].defaultHomePage = "";
				}
			}
		} 
		
		for (var j = elementsToRemove.length - 1; j >= 0 ; j--)
		{
			Arrays.removeElement(list[i].homePages, elementsToRemove[j]);
		}
	}
}

function validHomePage(homePage)
{
	for (var i = 0; i < allHomePages.length; i++)
	{
		if (allHomePages[i] == homePage)
		{
			return true;
		}
	}
	
	return false;
}

function pageLoad()
{
	document.getElementById("pasteSettings").disabled = true;
	
	if (isFilterTab)
	{
		AvailableUsers.showSearch();
	}
	else
	{
		AvailableUsers.showAll();	
	}
	
	var userAssignedTab = document.getElementById('user-assigned-tab');
	EventUtils.addEvent(userAssignedTab, 'click', userAssignedTab_onClick);
	userAssignedTab.style.display = "";
	
	var groupAssignedTab = document.getElementById('group-assigned-tab');
	EventUtils.addEvent(groupAssignedTab, 'click', groupAssignedTab_onClick);
	groupAssignedTab.style.display = "";
		
	EventUtils.addEvent(document.getElementById('user-search-results'), 'change', userChanged);
	EventUtils.addEvent(document.getElementById('user-all-results'), 'change', userChanged);
	EventUtils.addEvent(document.getElementById('user-assigned-results'), 'change', userChanged);
	EventUtils.addEvent(document.getElementById('user-all-tab'), 'click', userChanged);
	EventUtils.addEvent(document.getElementById('user-search-tab'), 'click', userChanged);
	EventUtils.addEvent(document.getElementById('user-assigned-tab'), 'click', userChanged);
		
	EventUtils.addEvent(document.getElementById('group-search-results'), 'change', groupChanged);
	EventUtils.addEvent(document.getElementById('group-all-results'), 'change', groupChanged);
	EventUtils.addEvent(document.getElementById('group-assigned-results'), 'change', groupChanged);
	EventUtils.addEvent(document.getElementById('group-all-tab'), 'click', groupChanged);
	EventUtils.addEvent(document.getElementById('group-search-tab'), 'click', groupChanged);
	EventUtils.addEvent(document.getElementById('group-assigned-tab'), 'click', groupChanged);
	
	dojo.connect("addHomePageToSelected", "markUnSaved");
	dojo.connect("markHomePageAsDefaultForSelected", "markUnSaved");
	dojo.connect("removeHomePageFromSelected", "markUnSaved");
	
	homePageAssignments.users.sort(homePageAssignmentSorter);
	homePageAssignments.groups.sort(homePageAssignmentSorter);
	
	validateAssignments(homePageAssignments.users);
	validateAssignments(homePageAssignments.groups);
}

function userChanged()
{
	//Users have their display formatted name as the text and their actual user
	//name as the value, so we need the value.
	currentlySelected = SelectUtils.getSelectedValues(AvailableUsers.select);
	
	//To get user display names we need the text values as well as the regular values.
	currentlySelectedTextValues = SelectUtils.getSelectedTextValues(AvailableUsers.select);
			
	if (currentlySelected.length == 0)
	{
		clearAllOnClick(false);
		return
	}
	else if (currentlySelected.length > 1)
	{
		clearAllOnClick(false);
		firstMultiSelectOperation = true;
	}
	else
	{
		showUserGroupSettings();
	}
}

function groupChanged()
{
	//Groups have the name in uppercase as the text and lowercase as the value, we need
	//the actual group name, so the text.
	currentlySelected = SelectUtils.getSelectedTextValues(AvailableGroups.select);
	currentlySelectedTextValues = currentlySelected; //so sorting and adding new options still works.
	
	if (currentlySelected.length == 0)
	{
		clearAllOnClick(false);
		return
	}
	else if (currentlySelected.length > 1)
	{
		firstMultiSelectOperation = true;
		clearAllOnClick(false);
	}
	else
	{
		showUserGroupSettings();
	}
}

function userAssignedTab_onClick(e)
{
	EventUtils.preventDefault(e);
	clearAllOnClick(false);
	showUserAssigned();
}

function groupAssignedTab_onClick(e)
{
	EventUtils.preventDefault(e);
	clearAllOnClick(false);
	showGroupAssigned();
}

/**
 * Show the User 'Assigned' tab.
 */
function showUserAssigned()
{
	var link = document.getElementById('user-assigned-tab');
	if (!TabUtils.activate(link)) return;

	AvailableUsers.select = document.getElementById('user-assigned-results');
	var assignedSelect = AvailableUsers.select;
	var list = getList();
	
	assignedSelect.length = 0;
	
	for (var i = 0; i < list.length; i++)
	{
		if (list[i].homePages.length > 0)
		{
			if (list[i].name == "{Everyone Else}")
			{
				list[i].displayName =  "<change:resource key='everyoneElse'/>"
				SelectUtils.addOption(assignedSelect, list[i].displayName, list[i].name, false);
				assignedSelect.options[assignedSelect.options.length - 1].style.color = "blue";
			}
			else
			{
				SelectUtils.addOption(assignedSelect, list[i].displayName, list[i].name, false);
			}
		}
	}
}

/**
 * Show the Group 'Assigned' tab.
 */
function showGroupAssigned()
{
	var link = document.getElementById('group-assigned-tab');
	if (!TabUtils.activate(link)) return;

	AvailableGroups.select = document.getElementById('group-assigned-results');
	var assignedSelect = AvailableGroups.select;
	var list = getList();
	
	assignedSelect.length = 0;
	
	for (var i = 0; i < list.length; i++)
	{
		if (list[i].homePages.length > 0)
		{
			//need to add sorting
			SelectUtils.addOption(assignedSelect, list[i].displayName, list[i].name, false);
		}
	}
}

function showUserGroupSettings()
{
	var list = getList();	
	var selected = currentlySelected[0];	
	var index = getUserGroupIndexFromList(list, selected);
	
	clearAllOnClick(false);
	
	if (index == -1)
	{
		return;
	}
	
	var checkboxes = document.selectHomePages.visibleBoxes;
	var length = checkboxes.length;
	
	if (length == undefined)
	{
		var array = list[index].homePages;
		
		if (Arrays.contains(array, eval(checkboxes.value)))
		{
			checkboxes.checked = true;
			
			var radio = document.getElementById("defaultRadio_0");
			radio.disabled = false;
			
			if (eval(checkboxes.value) == list[index].defaultHomePage)
			{				
				radio.checked = true;	
			}
		}	
	}
	else
	{
		for (var i = 0; i < length; i++)
		{		
			var array = list[index].homePages;

			if (Arrays.contains(array, eval(checkboxes[i].value)))
			{
				checkboxes[i].checked = true;
				
				var radio = document.getElementById("defaultRadio_" + i);
				radio.disabled = false;
				
				if (eval(checkboxes[i].value) == list[index].defaultHomePage)
				{				
					radio.checked = true;	
				}
			}	
		}
	}
}

function enablePasteSettings()
{
	var a = document.getElementById("pasteSettings");
	
	if (document.all)
	{
		a.disabled = false;
		a.style.color = "";
	}
	else
	{
		a.style.color = "";
	}
	
	a.style.cursor = "pointer";
	a.onclick = function() { pasteSettingsOnClick(); };
}

function addHomePageToSelected(homePage, isDefault)
{
	var list = getList();
	
	if ((list > 1) && (firstMultiSelectOperation))
	{
		clearAllOnClick(true);
	}
	
	for (var i = 0; i < currentlySelected.length; i++)
	{
		var selected = currentlySelected[i];
		var index = getUserGroupIndexFromList(list, selected);
								
		if (index == -1)
		{
			index = list.length;
			list[list.length] = new Object();
			list[index].name = selected;
			list[index].displayName = currentlySelectedTextValues[i];
			list[index].homePages = new Array();
		}
				
		var array = list[index].homePages;
		
		if (!Arrays.contains(array, homePage))
		{
			list[index].homePages[array.length] = homePage;		
		}
		
		if (isDefault)
		{
			list[index].defaultHomePage = homePage;
		}
		
		list[index].dirty = true;
		
		list.sort(homePageAssignmentSorter);
	}
}

function homePageAssignmentSorter(x, y)
{
	if (x.name == "{Everyone Else}")
	{
		return -1;
	}
	else if (y.name == "{Everyone Else}")
	{
		return 1;
	}
	
	return x.displayName.toLowerCase() < y.displayName.toLowerCase() ? -1 :
	 (x.displayName.toLowerCase() > y.displayName.toLowerCase() ? 1 : 0);
}

function removeHomePageFromSelected(homePage)
{
	var list = getList();
	
	for (var i = 0; i < currentlySelected.length; i++)
	{
		var selected = currentlySelected[i];
		var index = getUserGroupIndexFromList(list, selected);
		
		if (index == -1)
		{
			//didn't find the user, can't remove the home page.
			continue;
		}
		
		for (var x = 0; x < list[index].homePages.length; x++)
		{
			if (list[index].homePages[x] == homePage)
			{
				var array = list[index].homePages;
				Arrays.removeElement(array, x);
				break;
			}
		}
				
		if (list[index].defaultHomePage == homePage)
		{
			list[index].defaultHomePage = "";
		}
		
		list[index].dirty = true;
	}
}

function markHomePageAsDefaultForSelected(homePage)
{	
	var list = getList();
	
	for (var i = 0; i < currentlySelected.length; i++)
	{
		var selected = currentlySelected[i];
		var index = getUserGroupIndexFromList(list, selected);
		
		if (index == -1)
		{
			//didn't find the user, can't mark the home page as default. They
			//should already exist and this would be a problem if not.
			continue;
		}
		
		list[index].defaultHomePage = homePage;
		list[index].dirty = true;
	}
}

function unsetDefault()
{
	var list = getList();
	
	for (var i = 0; i < currentlySelected.length; i++)
	{
		var selected = currentlySelected[i];
		var index = getUserGroupIndexFromList(list, selected);
		
		if (index == -1)
		{
			//didn't find the user, can't unmark the home page as default.
			continue;
		}
		
		list[index].defaultHomePage = "";
		list[index].dirty = true;
		markUnSaved();
	}
	
	//If there is only one radio button in the list,
	//this will be an object instaead of an Array.
	var radios = document.selectHomePages.defaultHomePages;

	//Objects doesnot have length property.
	if (!radios.length)
	{
		radios.checked = false;
	}
	else
	{
		for (var i = 0; i < radios.length; i++)
		{
			if (radios[i].checked)
			{
				radios[i].checked = false;
				return;
			}
		}
	}
}

function getList()
{
	var sortBy = document.getElementById("sortBy");
	var list;
	
	if (sortBy.options[sortBy.selectedIndex].value == "users")
	{
		list = homePageAssignments.users;
	}
	else
	{
		list = homePageAssignments.groups;
	}
	
	return list;
}

function getUserGroupIndexFromList(list, name)
{
	var index = -1;
	
	for (var i = 0; i < list.length; i++)
	{
		if (list[i].name == name)
		{
			index = i;
			break;
		}
	}
	
	return index;
}

function clearSelectedUsersHomePages()
{	
	var list = getList();
	
	for (var i = 0; i < currentlySelected.length; i++)
	{
		var index = getUserGroupIndexFromList(list, currentlySelected[i]);
		
		if (index != -1)
		{
			list[index].defaultHomePage = "";
			list[index].homePages = new Array();
			list[index].dirty = true;
		}
	}
}


/**
 * Returns enablebled database count.
 */
function getEnabledDBsCount()
{
	var count = 0;

	for (var i = 0; i < databases.length; i++)
	{
		if (databases[i].enabled)
			count++;
	}

	return count;
}

//FUNCTION OVERRIDE!!
AvailableUsers.search = function(attribute, text)
{
	clearAllOnClick(false);
	var resultsSelect = document.getElementById('user-search-results');
	AvailableUsers.showLoadingMessage(resultsSelect);
	AvailableUsers.enableGo(false);
		
	if (attribute == 'group')
	{
		// 'group' is not an attribute, but a keyword that indicates we should
		// query for members of that group.
		var includeGroups = false;
		LdapGroupUtilsAjax.getMembers(
			window.token,
			text,
			includeGroups,
			callback);
	}
	else if (attribute == 'privilege')
	{
		if (getEnabledDBsCount() == 0)
		{
			PTAlert("<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='errNoDatabaseEnabled' --><!-- /WSLET -->");
			AvailableUsers.hideLoadingMessage(resultsSelect);
			AvailableUsers.enableGo(true);					
			return;
		}

		var dbNames = new Array();
		for (i = 0; i < databases.length; i++)
		{
			dbNames[i] = databases[i].name;
		}
		LdapUserUtilsAjax.getUserListWithCmRole(
			window.token,			
			text,
			dbNames,
			callback);		
	}
	else
	{
		LdapUserUtilsAjax.queryUsers(
			window.token,
			attribute,
			text,
			callback);
	}
	
	function callback(members)
	{
		AvailableUsers.hideLoadingMessage(resultsSelect);
		AvailableUsers.enableGo(true);
		//custom code
		SelectUtils.addOption(resultsSelect, "<change:resource key='everyoneElse'/>", "{Everyone Else}", false);
		resultsSelect.options[0].style.color = "blue";
		AvailableUsers.setDisplayNames(resultsSelect, members);
	
		//custom code, removed if block.
		try
		{
			var textedit;
			
			if (document.getElementById('search-txtBox').style.display != 'none')
			{
				textedit = document.getElementById('user-search-text');				
			}
			else
			{
				textedit = document.getElementById("textBox");
			}
			
			textedit.select();
			textedit.focus();			
		}
		catch (e)
		{
			// ignore. Probably was hidden by the user after switching tabs.
		}
		
		if (AvailableUsers.onSearchResults)
		{
			AvailableUsers.onSearchResults();
		}
	};
};

//FUNCTION OVERRIDE!!
AvailableUsers.populateAll = function()
{
	var membersSelect = document.getElementById('user-all-results');
	AvailableUsers.showLoadingMessage(membersSelect);
	LdapUserUtilsAjax.getUsers(
		window.token,
		callback);
	
	function callback(members)
	{
		AvailableUsers.hideLoadingMessage(membersSelect);
		SelectUtils.addOption(membersSelect, "<change:resource key='everyoneElse'/>", "{Everyone Else}", false);
		membersSelect.options[0].style.color = "blue";
		AvailableUsers.setDisplayNames(membersSelect, members);
	};
};

//FUNCTION OVERRIDE!!
AvailableGroups.searchGroups_onSubmit = function(e)
{
	clearAllOnClick(false);
	EventUtils.preventDefault(e);

	var textedit = document.getElementById('group-search-text');
	var text = textedit.value;
	
	LdapGroupUtilsAjax.queryGroups(window.token, text, callback);

	var resultsSelect = document.getElementById('group-search-results');
	resultsSelect.options.length = 0;

	function callback(members)
	{
		if (AvailableGroups.filterGroups)
		{
			members = AvailableGroups.filterGroups(members);
		}

		AvailableGroups._setMembers(
			resultsSelect, members);

		textedit.select();
		textedit.focus();

		if (AvailableGroups.onSearchResults)
		{
			AvailableGroups.onSearchResults();
		}
	};
};

EventUtils.addEvent(window, 'load', pageLoad);
	</script>
</head>
<body>

<table class="barHeading">
<tr>
	<th><change:resource key='assignDefaultHomePages'/></th>
	<th style="text-align: right;">
		<a href="javascript:openHelp('${user.role}', 39)" title="<change:resource key='assignDefaultHpHelp'/>"><change:resource key="lbl01070"/></a>
	</th>
</tr>
</table>

<div>
	<change:resource key='lbl00721'/>
	<select id="sortBy" onchange="javascript:sortByOnChange(this)">
		<option value="users"><change:resource key='lbl00160'/></option>
		<option value="groups"><change:resource key='groups'/></option>
	</select>
</div>

<table cellpadding="5" cellspacing="0">
<tr>
	<td width="240px">
		<change:wsletExpander>
			<div id="usersDiv">
				<!-- WSLET CODE=PTInclude -->
				<!-- PARAM NAME=custom_controls/available_users.CUSTOM -->
				<!-- PARAM NAME=SUB_SHOW_FORM VALUE=submit -->
				<!-- /WSLET -->
			</div>
			
			<div id="groupsDiv" style="display: none">
				<!-- WSLET CODE=PTInclude -->
				<!-- PARAM NAME=custom_controls/available_groups.CUSTOM -->
				<!-- PARAM NAME=SUB_SHOW_FORM VALUE=submit -->
				<!-- /WSLET -->
			</div>
		</change:wsletExpander>
	</td>
	<td>
		<br>
		<form name="selectHomePages">
		<div class="tableContainer" id="data">
			<table class="homePages" cellspacing="0">
			<thead>
			<tr>
				<td width="70%" nowrap valign="top">
					<change:resource key="homePages"/>
				</td>
				<td width="15%" nowrap class="centered" valign="top">
					<change:resource key="visible"/>
				</td>
				<td width="15%" nowrap class="centered" valign="top">
					<change:resource key="default"/>
					<br>
					<a href="javascript: unsetDefault();"><font size="-2"><change:resource key="unset"/></font></a>
				</td>
			</tr>
			</thead>
			<tbody>
				<c:forEach items="${homePages.homePages}" var="homePage" varStatus="status">
					<tr>
						<td align="left">
							<c:out value="${homePage.name}"/>
						</td>
						<td class="centered">
							<input type="checkbox" name="visibleBoxes" value="<change:javaScriptEscape value="${homePage.name}"/>" 
							onclick="javascript:visibleOnClick(this, '${status.index}');">
						</td>
						<td class="centered">
							<input type="radio" name="defaultHomePages" id="defaultRadio_${status.index}" value="<change:javaScriptEscape value="${homePage.name}"/>" 
								onclick="javascript: markHomePageAsDefaultForSelected(<change:javaScriptEscape value="${homePage.name}"/>);" DISABLED>
						</td>
					</tr>
				</c:forEach>
			</tbody>
			</table>
		</div>		
		<div style="text-align: right; margin-top: 5px">
			<a href="javascript:selectAllOnClick();"><change:resource key="lbl00599"/></a>
			|
			<a href="javascript:clearAllOnClick(true);"><change:resource key="lbl00717"/></a>
			|
			<a href="javascript:copySettingsOnClick();"><change:resource key="copySettings"/></a>
			|
			<a href="#" id="pasteSettings" style="color: gray; cursor: default;" DISABLED><change:resource key="pasteSettings"/></a>
		</div>
		</form>
	</td>
</tr>
</table>

<div style="text-align: center;">
	<hr>
	<button type="button" id="saveButton" onClick="saveOnClick()"><change:resource key='lbl00592'/></button>
</div>

<br>

<center>
	<div class="note">
		<p>
			<change:resource key="assignDefaultsInfo"/>
		</p>
	</div>
</center>

<form name="saveHomePageAssignments" action="<change:urlCreator webResource='BASEURL'/>/saveHomePageAssignments.do" class="hiddenForm" method="POST" target="_self">
	<input name="token" type="hidden" value="${user.token}">
	<input name="assignmentsAsJSON" type="hidden">
</form>

</body>
</html>
