<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<!-- forms\user_framework\home_page_report_format_editor.jsp -->
<%@ taglib prefix="change" uri="http://www.telelogic.com/change" %>

<html>
<head>
	<title></title>
	
	<style type="text/css">
<!--

<change:wsletExpander>
	<!-- WSLET CODE=PTInclude -->
	<!-- PARAM NAME=styles/default.css -->
	<!-- PARAM NAME=styles/tabs.css -->
	<!-- PARAM NAME=styles/menu.css -->
	<!-- /WSLET -->
</change:wsletExpander>

BUTTON.columnButton
{
	width: 80px;
	display: block;
}

-->
	</style>
	<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dojo/dojo/dojo.js"></script>
	<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dwr/engine.js"></script>
	<script type="text/javascript" src="dwr/interface/LdapUserUtilsAjax.js"></script>
	
	<script type="text/javascript">
dojo.addOnLoad(report_load);
<!--

<change:wsletExpander>
	<!-- WSLET CODE=PTLoadData -->
	<!-- PARAM NAME=CCM_SECURITY_DATA -->
	<!-- PARAM NAME=CCM_DELIMITER -->
	<!-- PARAM NAME=CCM_SUB_DELIMITER -->
	<!-- /WSLET -->
</change:wsletExpander>

<change:wsletExpander>
	<!-- WSLET CODE=PTInclude -->
	<!-- PARAM NAME=EventUtils.js -->
	<!-- /WSLET -->
</change:wsletExpander>

<change:wsletExpander>
	<!-- WSLET CODE=PTInclude -->
	<!-- PARAM NAME=ptalert.js -->
	<!-- PARAM NAME=formload.js -->
	<!-- PARAM NAME=hyperlink.js -->
	<!-- PARAM NAME=domUtilities.js -->
	<!-- PARAM NAME=queryAndReportPrivileges.js -->
	<!-- PARAM NAME=Shim.js -->
	<!-- PARAM NAME=Layout.js -->
	<!-- PARAM NAME=MessageFormat.js -->
	<!-- /WSLET -->
</change:wsletExpander>

var attribute_scope = <change:userPreference value="attribute_scope" defaultValue="" escape="true"/>;

<change:wsletExpander>
	<!-- WSLET CODE=PTInclude -->
	<!-- PARAM NAME=AttributeScopeMenu.js -->
	<!-- /WSLET -->
</change:wsletExpander>

<change:wsletExpander>
	<!-- WSLET CODE=PTDataListBox -->
	<!-- PARAM NAME=CCM_ONLOAD_DATA VALUE=PROBLEMTASKOBJECTATTRS -->
	<!-- PARAM NAME=JAVASCRIPT_IDENTIFIER VALUE=SOURCE_ATTRS -->
	<!-- /WSLET -->
</change:wsletExpander>

var gAttributeNamesToLabels = mapAttributeNamesToLabels();

// constants
var SUBREPORT_TYPE_CR = 17;
var SUBREPORT_TYPE_TASK = 18;
var SUBREPORT_TYPE_OBJECT = 19;

// This dialog needs to make a local copy of the report format so that changes to sorting
// and attributes can be made directly to the object itself.
var formatObject = null;
var activeSubReport = null;

function getContextReport()
{
	if (!this.contextReport) // lazy initialization of function variable
	{
		this.contextReport = eval('(' + parent.getReportJson() + ')'); 
	}
	
	return this.contextReport;
}
	
function report_load()
{
	formatObject = getContextReport();
	unHideItems();
	setUpHeader();
	createTabs();
	activateFirstTab();
	setUpSpanning();
	setUpExtraEvents();
	SetFormLoading(false);
}

function isChartStyle()
{
	if ((formatObject.style == "VBarChart") || (formatObject.style == "HBarChart") ||
	    (formatObject.style == "PieChart") || (formatObject.style == "LineChart"))
	{
		return true;
	}
	
	return false;
}

function isMatrixStyle()
{
	if (formatObject.style == "Matrix")
	{
		return true;
	}
	
	return false;
}

function unHideItems()
{
	if ((!isChartStyle()) && (!isMatrixStyle()))
	{
		document.getElementById("spanning").style.display = "";
		document.getElementById("blankButton").style.display = "";
		document.getElementById("sortOptions").style.display = "";
		document.getElementById("upButton").style.display = "";
		document.getElementById("downButton").style.display = "";
	}
	
	if (isMatrixStyle())
	{
		document.getElementById("upButton").style.display = "";
		document.getElementById("downButton").style.display = "";
	}
}

function setUpExtraEvents()
{
	if ((isChartStyle()) || (isMatrixStyle()))
	{
		EventUtils.addEvent(document.getElementById('addButton'), 'click', enableDisableAddButton);
		EventUtils.addEvent(document.getElementById('removeButton'), 'click', enableDisableAddButton);
	}
}

function enableDisableAddButton()
{
	var selectedAttrs = document.getElementById("selectedAttributes");
					
	if (selectedAttrs.length == 0)
	{
		document.getElementById("addButton").disabled = false;
	}
	else if (selectedAttrs.length == 1)
	{
		if (isChartStyle())
		{
			document.getElementById("addButton").disabled = true;
		}
		else
		{
			document.getElementById("addButton").disabled = false;
		}
	}
	else if (selectedAttrs.length == 2)
	{
		if (isMatrixStyle())
		{
			document.getElementById("addButton").disabled = true;
		}
		else
		{
			document.getElementById("addButton").disabled = false;
			selectedAttrs.length = 0;
			PTAlert("<change:resource key="chartTooManyAttribute"/>",1);
		}
	}
	else 
	{
		if (isMatrixStyle())
		{
			document.getElementById("addButton").disabled = false;
			selectedAttrs.length = 1;
			PTAlert("<change:resource key="matrixTooManyAttribute"/>",1);
		}
		else if (isChartStyle())
		{
			document.getElementById("addButton").disabled = false;
			selectedAttrs.length = 0;
			PTAlert("<change:resource key="chartTooManyAttribute"/>",1);
		}
	}
}

function setUpHeader()
{	
	var name = document.createTextNode(formatObject.name);
	document.getElementById("name").appendChild(name);
	
	var description = document.createTextNode(formatObject.description);
	document.getElementById("description").appendChild(description);
}

function createTabs()
{
	var subReports = formatObject.sub_reports;

	if (subReports.length == 1) // don't show tabs
	{
		document.getElementById("tabSection").style.display = "none";
	}
	
	var ul = document.getElementById("tabsList");
	removeChildren(ul);

	var label, toolTip;

	for (var i = 0; i < subReports.length; i++)
	{
		switch (subReports[i].def_type)
		{
			case SUBREPORT_TYPE_CR:
				label = "<change:resource key="lbl00762"/>";
				toolTip = "<change:resource key="alt00083"/>";
				break;
			case SUBREPORT_TYPE_TASK:
				label = "<change:resource key="lbl00032"/>";
				toolTip = "<change:resource key="alt00084"/>";
				break;
			case SUBREPORT_TYPE_OBJECT:
				label = "<change:resource key="lbl00130"/>";
				toolTip = "<change:resource key="alt00085"/>";
				break; 
		}
		var li = createTab(label, toolTip, subReports[i]);
		ul.appendChild(li);
	}
}

function createTab(label, toolTip, subReport)
{
	var a = document.createElement("a");
	a.href = "#";
	a.onclick = tab_onClick;
	a.title = toolTip;
	a.subReport = subReport;
	a.appendChild(document.createTextNode(label));

	var li = document.createElement("li");
	li.appendChild(a);
	return li;
}

function tab_onClick(evt)
{
	if (IsFormLoading())
	{
		return;
	}

	// save off changes in current tab
	updateFormatObject();

	var a = getElementReceivingEvent(evt);
	activateTab(a);
	window.gScopeMenu.refreshScope();
}

function getElementReceivingEvent(evt)
{
	evt = evt ? evt : window.event;
	return evt.target ? evt.target : evt.srcElement;
}

function activateTab(tabHyperLink)
{
	activeSubReport = tabHyperLink.subReport;
	focusTab(tabHyperLink);
	loadSubReport(tabHyperLink.subReport);
}

function activateFirstTab()
{
	var ul = document.getElementById("tabsList");
	var a = getElementByTagName(ul, "a");
	activateTab(a);
}

function setUpSpanning()
{
	//Means this is a column report.
	if (!spanningOn())
	{
		document.getElementById("spanning").style.display = "none";
		document.getElementById("blankButton").style.display = "none";
	}
}

function spanningOn()
{
	// Auto-generated column-based formats have label template value, block formats do not.
	// Only block formats support spanning.
	return formatObject.sub_reports[0].label_template.length == 0;
}

function focusTab(tabHyperLink)
{
	var li = tabHyperLink.parentNode;
	var siblings = li.parentNode.getElementsByTagName("li");

	for (var i = 0; i < siblings.length; i++)
	{
		var sibling = siblings[i];
		sibling.getElementsByTagName("a")[0].className = (sibling == li ? "current" : "");
	}
}

function loadSubReport(subReport)
{
	document.lastSubReport = subReport;

	loadSelectedAttributes(subReport);
	selectedAttributes_onChange();
	loadSortOptions(subReport, gAttributeNamesToLabels);
}

function mapAttributeNamesToLabels()
{
	var map = {};
	var attributeArrays;
	if (<change:wsletExpander><!-- WSLET CODE=GetSystemValue --><!-- PARAM NAME=NAME VALUE=SUPPORT_TASKS --><!-- /WSLET --></change:wsletExpander>) 
	{
		attributeArrays = [SOURCE_ATTRS.REPORTABLE_ATTRIBUTES, SOURCE_ATTRS.REPORTABLE_TASK_ATTRIBUTES, SOURCE_ATTRS.REPORTABLE_OBJECT_ATTRIBUTES];
	}
	else
	{
		attributeArrays = [SOURCE_ATTRS.REPORTABLE_ATTRIBUTES];
	}
	
	for (var attributesIndex = 0; attributesIndex < attributeArrays.length; attributesIndex++)
	{
		var attributes = attributeArrays[attributesIndex];

		for (var i = 0; i < attributes.length; i++)
		{
			map[attributes[i][0]] = attributes[i][1];
		}
	}

	return map;
}

function loadSourceAttributes(subReport, scope)
{
	var lbx = document.getElementById("sourceAttributes");
	lbx.length = 0;

	var list;
	var isMirrored = ((scope) && (scope.indexOf(gMirroredMenuName) == 0));
	
	if (isMirrored)
	{
		//we are dealing with the mirrored source list so create a new list to use.
		list = new Array();
		
		for (var i = 0; i < gMirroredAttributes.length; i++)
		{
			list[i] = new Array();
			list[i][0] = gMirroredAttributes[i].name;
			list[i][1] = gMirroredAttributes[i].name;
			list[i][2] = "CCM_STRING";
		}
	}
	else
	{
		switch (subReport.def_type)
		{
			case SUBREPORT_TYPE_CR:
				list = SOURCE_ATTRS.REPORTABLE_ATTRIBUTES;
				break;
			case SUBREPORT_TYPE_TASK:
				list = SOURCE_ATTRS.REPORTABLE_TASK_ATTRIBUTES;
				break;
			case SUBREPORT_TYPE_OBJECT:
				list = SOURCE_ATTRS.REPORTABLE_OBJECT_ATTRIBUTES;
				break;
		}
	}
	
	if (list == null)
	{
		return;
	}
	
	var attributesInScopeSet = null;

	//Don't set up scope information if using mirrored attributes.
	if (scope && !isMirrored)
	{
		var attributesInScope = gAttributeScopes[scope];
		attributesInScopeSet = {}

		for (var i = 0; i < attributesInScope.length; i++)
		{
			attributesInScopeSet[attributesInScope[i]] = true;
		}
	}

	var restrictWebtypes = restrictWebTypes();
	var x = 0;
	
	for (var i = 0; i < list.length; i++)
	{
		var name = list[i][0];

		if (attributesInScopeSet
			&& !attributesInScopeSet[name])
		{
			continue;
		}

		if (restrictWebtypes)
		{
			var webType = list[i][2];
			
			if ((webType == "CCM_TEXT") || (webType == "CCM_ANNOTATED_TEXT") || (webType == "CCM_SUBSCRIPTION") ||
				(webType == "CCM_E_SIGNATURE") || (webType == "CCM_DATE")  || (webType == "CCM_EXTENDED_TEXT") ||
				(webType == "CCM_PAGE_NAVIGATE") || (webType == "CCM_START_SEC") || (webType == "CCM_END_SEC") ||
				(webType == "CCM_VISUAL_STATUS") || (webType == "CCM_PROGRESS_BAR") || (webType == "OSLC_LINK"))
			{
				continue;
			}
		}

		lbx.options[x] = new Option(list[i][1], list[i][0]);
		x++;
	}
}

function restrictWebTypes()
{
	if ((isChartStyle()) || (isMatrixStyle()))
	{
		return true;
	}
	
	return false;
}

function loadSelectedAttributes(subReport)
{
	var lbx = document.getElementById("selectedAttributes");
	lbx.length = 0;

	var attributes = parseReportAttributes(subReport.attributes, false);
	
	for (var i = 0; i < attributes.length; i++)
	{
		var name = attributes[i].name;
		var label = gAttributeNamesToLabels[name];
		
		label = (label == null) ? name : label;

		var option = new Option(label, name);
		option.span = attributes[i].span;
		lbx.options[i] = option;
	}
	
	if ((isChartStyle()) || (isMatrixStyle()))
	{
		enableDisableAddButton();
	}
}

function add_onClick()
{
	var lbx = document.getElementById("sourceAttributes");
	var selIndex = lbx.selectedIndex;

	if (selIndex == -1)
	{
		alert("<change:resource key="err00138"/>");
		lbx.focus();
		return;
	}

	var didAppend = false;
	for (var i = selIndex; i < lbx.length; i++)
	{
		var option = lbx.options[i];
		if (option.selected && !hasAttribute(option.value))
		{
			appendOption(option.text, option.value, false);
			didAppend = true;
		}
	}

	if (didAppend)
	{
		selectedAttributes_onChange();

		// refresh the sorting options
		updateFormatObject();
		loadSortOptions(activeSubReport, gAttributeNamesToLabels);
	}
}

function hasAttribute(attribute)
{
	var selectedAttributes = document.getElementById("selectedAttributes");

	for (var i = 0; i < selectedAttributes.length; i++)
	{
		if (selectedAttributes.options[i].value == attribute)
			return true;
	}

	return false;
}

function blank_onClick()
{
	appendOption("{BLANK}", "{BLANK}", false);
	selectedAttributes_onChange();
}

function appendOption(label, value, span)
{	
	var lbx = document.getElementById("selectedAttributes");
	var selIndex = lbx.selectedIndex;
	var origLength = lbx.length;

	lbx.options[origLength] = new Option(label, value, true, true);
	lbx.options[origLength].span = span;

	if (selIndex != -1)
	{
		var currentPos = origLength;
		var hopsUp = currentPos - selIndex - 1;

		for (var i = 1; i <= hopsUp; i++, currentPos--)
		{
			swapOptions(lbx.options[currentPos], lbx.options[currentPos - 1]);
		}
	}
}

function swapOptions(option1, option2)
{
	var tempOption = new Option();
	
	copyOption(option1, tempOption);
	copyOption(option2, option1);
	copyOption(tempOption, option2);	
}

function copyOption(fromOption, toOption)
{
	toOption.text = fromOption.text;
	toOption.selected = fromOption.selected;
	toOption.value = fromOption.value;
	toOption.span = fromOption.span;
}

function remove_onClick()
{
	var lbx = document.getElementById("selectedAttributes");
	var selIndex = lbx.selectedIndex;
	
	if (selIndex == -1)
	{
		alert("<change:resource key="err00138"/>");
		lbx.focus();
		return;
	}

	removeAttributeFromSortOptions(lbx.options[selIndex].value);
	lbx.options[selIndex] = null;
	lbx.focus();
	selectedAttributes_onChange();
}

function selectedAttributes_onChange()
{
	if (!spanningOn())
	{
		return;
	}

	var lbx = document.getElementById("selectedAttributes");
	var selIndex = lbx.selectedIndex;
	var cbx = document.getElementById("span");

	if (selIndex == -1)
	{
		cbx.checked = false;
		cbx.disabled = true;
	}
	else
	{
		cbx.checked = lbx.options[selIndex].span;
		cbx.disabled = false;
	}
}

function up_onClick()
{
	var lbx = document.getElementById("selectedAttributes");
	var selIndex = lbx.selectedIndex;
	
	if (selIndex == -1)
	{
		alert("<change:resource key="err00142"/>");
		lbx.focus();
		return;
	}
	
	if (selIndex > 0)
	{
		swapOptions(lbx.options[selIndex], lbx.options[selIndex - 1]);
	}
}

function down_onClick()
{
	var lbx = document.getElementById("selectedAttributes");
	var selIndex = lbx.selectedIndex;
	
	if (selIndex == -1)
	{
		alert("<change:resource key="err00142"/>");
		return;
	}
	
	if (selIndex < lbx.length - 1)
	{
		swapOptions(lbx.options[selIndex], lbx.options[selIndex + 1]);		
	}
}

function span_onClick()
{
	var lbx = document.getElementById("selectedAttributes");
	lbx.options[lbx.selectedIndex].span = document.getElementById("span").checked;
}

function canSave()
{
	if (isMatrixStyle() && document.getElementById("selectedAttributes").length != 2)
	{
		alert("<change:resource key="matrixStyleTwoAttributes"/>");
		return false;
	}
	
	if (document.getElementById("selectedAttributes").length == 0)
	{
		alert("<change:resource key="err00139"/>");
		return false;
	}

	return true;
}

function getAttributes(subReportIndex)
{
	updateFormatObject();
		
	if (formatObject.sub_reports[subReportIndex] != null)
	{
		return formatObject.sub_reports[subReportIndex].attributes;
	}
	else
	{
		return "NO_ACTION";
	}
}

function getSortOrder(subReportIndex)
{
	updateFormatObject();
	
	if (formatObject.sub_reports[subReportIndex] != null)
	{
		return formatObject.sub_reports[subReportIndex].sort_order;
	}
	else
	{
		return "NO_ACTION";
	}
}

function getSelectedAttributes()
{
	var retval = "";

	var lbx = document.getElementById("selectedAttributes");
	var selIndex = lbx.length;

	for (var i = 0; i < selIndex; i++)
	{
		var attrName = lbx.options[i].value;
		var attrSpan = lbx.options[i].span;
		var attrSort = i;
		
		if (retval != "")
		{
			retval += delimiter;
		}
		retval += attrName + sub_delimiter + attrSort + sub_delimiter + attrSpan;
	}

	return retval;
}

function updateFormatObject()
{
	activeSubReport.attributes = getSelectedAttributes();
	activeSubReport.sort_order = getSelectedSortOrder();
}

function onChangeScope(scope)
{
	loadSourceAttributes(document.lastSubReport, scope);	
}

// Merges the mirrored attributes into the attribute scope menu. This creates a new object property
// with the name of the given resource string and then creates an array of all the mirrored attribute
// names. Also changed the source loader to check if the attribute is mirrored or not.
function mergeMirroredAttributesIntoScope()
{
	if (gMirroredAttributes.length == 0)
	{
		return;
	}
	
	gAttributeScopes[gMirroredMenuName] = new Array();
	
	for (var i = 0; i < gMirroredAttributes.length; i++)
	{ 
		gAttributeScopes[gMirroredMenuName][i] = gMirroredAttributes[i].name;
	}
}

function isMirroredAttribute(attributeAlias)
{
	for (var i = 0; i < gMirroredAttributes.length; i++)
	{
		if (gMirroredAttributes[i].alias == attributeAlias)
		{
			return true;
		}
	}
	
	return false;
}

var gAttributeScopes = <change:wsletExpander><!-- WSLET CODE=GetAttributeScopes --> <!-- /WSLET -->;</change:wsletExpander>
var gMirroredAttributes = <change:wsletExpander><!-- WSLET CODE=GetMirroredAttributes --><!-- /WSLET -->;</change:wsletExpander>
var gMirroredMenuName = "<change:resource key='mirroredAttributesMenu'/>";

mergeMirroredAttributesIntoScope();

var lastScope = window.attribute_scope == ''
	? window.undefined
	: attribute_scope;

var gScopeMenu = new AttributeScopeMenu(
		'attribute-label',
		'attribute-label-scoped',
		'attribute-scope-label',
		'attribute-scope-link',
		gAttributeScopes,
		lastScope);

gScopeMenu.onChangeScope = onChangeScope;
gScopeMenu.usePluralLabels();


-->
	</script>
</head>

<body>
	<table width="100%" class="barHeading">
	<tr>
		<th><change:resource key="editFormatHeading"/><span id="name">&nbsp;&#151;&nbsp;</span></th>
	</tr>
	</table>

	<table width="100%">
	<tr>
		<td align="right" valign="top"><label for="description" class="label_decoration"><change:resource key="lbl00070"/>&nbsp;</label></td>
		<td id="description"></td>
	</tr>
	<tr>
		<td colspan="2" align="center" style="padding-top: 10px; padding-bottom: 10px;">
			<div id="tabSection" style="margin: auto 5% 5px 5%;">
				<ul id="tabsList" class="tabbedList">
					<li></li>
				</ul>
			</div>

			<table>	
			<tr>
				<td>
					<label style="white-space: normal; display: none;" for="attribute" title="<change:resource key="scopedAttributeTooltip"/>" id="attribute-label-scoped">
						
						<a id="attribute-scope-link" style="white-space: normal;" class="label_decoration subtle-link" href="#">
							<span id="attribute-scope-label"></span>
							<img src="<change:urlCreator webResource="PTIMAGES"/>sort_arrow_down.gif">
						</a>
					</label>

					<label id="attribute-label" for="sourceAttributes" class="label_decoration" style="display: none;">
						<change:resource key="lbl00194"/>
					</label>
				</td>
				<td>
					&nbsp;
				</td>
				<td>
					<label for="selectedAttributes" class="label_decoration"><change:resource key="lbl00195"/></label>
				</td>
				<td>
					&nbsp;
				</td>
			</tr>
			<tr>
				<td>
					<select multiple name="sourceAttributes" id="sourceAttributes" size="8">
						<option></option>
					</select>
				</td>
				<td valign="top" style="padding-left: 5px; padding-right: 5px;">
					<button id="addButton" class="columnButton" onclick="add_onClick();" title="">
						<change:resource key="lbl00738"/>
					</button>
					<button class="columnButton" onclick="blank_onClick();" title="" id="blankButton" style="display: none">
						<change:resource key="lbl00763"/>
					</button>
					<button id="removeButton" class="columnButton" onclick="remove_onClick();" title="">
						<change:resource key="lbl00739"/>
					</button>
				</td>
				<td>
					<select name="selectedAttributes" id="selectedAttributes" size="8" onchange="selectedAttributes_onChange()">
						<option></option>
					</select>
				</td>
				<td valign="top" style="padding-left: 5px;" nowrap>
					<button id="upButton" class="columnButton" onclick="up_onClick();" title="" style="display: none">
						<change:resource key="lbl01112"/>
					</button>
					<button id="downButton" class="columnButton" onclick="down_onClick();" title="" style="display: none"> 
						<change:resource key="lbl01113"/>
					</button>
					<div id="spanning" style="display: none">
						<input type="checkbox" name="span" id="span" onclick="span_onClick()">
						<label for="span">
							<change:resource key="lbl00196"/>
						</label>
					</div>
				</td>
			</tr>
			</table>
		</td>
	</tr>
	<tr id="sortOptions" style="display: none">
		<td align="right" valign="top" class="label_decoration"><change:resource key="lbl01144"/>&nbsp;</td>
		<td align="left">
			<change:wsletExpander>
				<!-- WSLET CODE=PTInclude -->
				<!-- PARAM NAME=custom_controls/sortOptions.CUSTOM -->
				<!-- /WSLET -->
			</change:wsletExpander>
		</td>
	</tr>
	</table>

	</BODY>
</html>
