<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:template match="/">		
		<html>
			<title>
				<xsl:text disable-output-escaping="yes">
					&lt;!-- WSLET CODE=PTString -->&lt;!-- PARAM NAME=RESOURCE_STRING VALUE='lblAdminAuditLog' -->&lt;!-- /WSLET -->
				</xsl:text>
			</title>
			<head>
				<style type="text/css">
				<xsl:text disable-output-escaping="yes">
					&lt;!-- WSLET CODE=PTInclude -->
					&lt;!-- PARAM name=styles/default_admin.css -->
					&lt;!-- PARAM name=styles/default.css -->
					&lt;!-- /WSLET -->					
				</xsl:text>
					
					.audit-table 
					{ 
						border: solid gray 1px;
						border-collapse: collapse;
						empty-cells: show;
						width: 100%;
					}
					.audit-table thead
					{
						background-color: silver;
						font-weight: bold;
						white-space: nowrap;
					}
					.audit-table td 
					{ 
						padding: .25em .75em;
						border-top: gray solid 1px;
						border-left: gray solid 1px;
						vertical-align: top;
						white-space: nowrap;
					}
				</style>
				
				<script language="JavaScript" type="text/javascript">
					<xsl:text disable-output-escaping="yes">
						&lt;!-- WSLET CODE=PTInclude -->
						&lt;!-- PARAM NAME=formload.js -->
						&lt;!-- PARAM NAME=browserDetect.js -->
						&lt;!-- PARAM NAME=ptalert.js -->
						&lt;!-- /WSLET -->
					</xsl:text>
					<xsl:text disable-output-escaping="yes">
						&lt;!-- WSLET CODE=PTLoadData -->
						&lt;!-- PARAM NAME=CCM_SECURITY_DATA -->
						&lt;!-- PARAM NAME=CCM_TOKEN -->
						&lt;!-- PARAM NAME=CCM_ROLE -->
						&lt;!-- /WSLET -->
					</xsl:text>
					
					function refresh_onClick()
					{
						window.document.pt_form_load.method = "POST";
						window.document.pt_form_load.action = 
							<xsl:text disable-output-escaping="yes">
								"&lt;!-- WSLET CODE=PTAdmin -->" +
								"&lt;!-- PARAM NAME=SERVLET_PATH VALUE=PTADMINACTION_SERVLET -->" +
								"&lt;!-- /WSLET -->";
							</xsl:text>
							
						window.document.pt_form_load.target = "_self";
						window.document.pt_form_load.ACTION_FLAG.value = "viewauditlog";
						window.document.pt_form_load.role.value = role;
						window.document.pt_form_load.token.value = token;
						window.document.pt_form_load.submit();
					}
					
					function downloadAudit_OnClick()
					{
						window.document.pt_form_load.method = "POST";
						window.document.pt_form_load.action = 
							<xsl:text disable-output-escaping="yes">
								"&lt;!-- WSLET CODE=PTAdmin -->" + 
								"&lt;!-- PARAM NAME=SERVLET_PATH VALUE=BASE_PATH -->" + 
								"&lt;!-- /WSLET -->/downloadAuditLogInfo.do";
							</xsl:text>
						window.document.pt_form_load.role.value = role;
						window.document.pt_form_load.token.value = token;
						window.open("", "downloadAuditLog", "<xsl:text disable-output-escaping="yes"> &lt;!-- WSLET CODE=PTAdmin -->" + 
						"&lt;!-- PARAM NAME=FILE_DOWNLOAD_WINDOW_OPTIONS -->" + 
						"&lt;!-- /WSLET --> </xsl:text>").focus();
						window.document.pt_form_load.target = "downloadAuditLog";
						BrowserDetect.doSubmitForm(window.document.pt_form_load);
					}
				</script>
			</head>
			<body>
				<table width="100%" class="barHeading">
					<tbody>
						<tr>
							<th>
								<b>
									<xsl:text disable-output-escaping="yes">
									&lt;!-- WSLET CODE=PTString -->&lt;!-- PARAM NAME=RESOURCE_STRING VALUE='lblAdminAuditLog' -->&lt;!-- /WSLET -->
									</xsl:text>
								</b>
							</th>
							<td align="right">
								<a href="javascript:refresh_onClick();" title= "&lt;!-- WSLET CODE=PTString -->&lt;!-- PARAM NAME=RESOURCE_STRING VALUE='refreshAdminAuditLog' -->&lt;!-- /WSLET -->">  
									<xsl:text disable-output-escaping="yes">
										&lt;!-- WSLET CODE=PTString -->&lt;!-- PARAM NAME=RESOURCE_STRING VALUE='lbl01116' -->&lt;!-- /WSLET -->
									</xsl:text>
								</a>
								|
								<a href="javascript:downloadAudit_OnClick();" title= "&lt;!-- WSLET CODE=PTString -->&lt;!-- PARAM NAME=RESOURCE_STRING VALUE='downloadAdminAuditLog' -->&lt;!-- /WSLET -->">    
									<xsl:text disable-output-escaping="yes">
										&lt;!-- WSLET CODE=PTString -->&lt;!-- PARAM NAME=RESOURCE_STRING VALUE='lbl01117' -->&lt;!-- /WSLET -->
									</xsl:text>
								</a>
								|
								<a href="javascript:window.print();" title= "&lt;!-- WSLET CODE=PTString -->&lt;!-- PARAM NAME=RESOURCE_STRING VALUE='printAdminAuditLog' -->&lt;!-- /WSLET -->">    
									<xsl:text disable-output-escaping="yes">
										&lt;!-- WSLET CODE=PTString -->&lt;!-- PARAM NAME=RESOURCE_STRING VALUE='printAction' -->&lt;!-- /WSLET -->
									</xsl:text>
								</a>
							</td>
						</tr>
					</tbody>
				</table>
				
				<table class="audit-table">
						<thead>
							<tr>
								<td>
								<b>
									<xsl:text disable-output-escaping="yes">
										&lt;!-- WSLET CODE=PTString -->&lt;!-- PARAM NAME=RESOURCE_STRING VALUE='lbl00175' -->&lt;!-- /WSLET -->
									</xsl:text>								
								</b>
								</td>
								<td>
								<b>
									<xsl:text disable-output-escaping="yes">
										&lt;!-- WSLET CODE=PTString -->&lt;!-- PARAM NAME=RESOURCE_STRING VALUE='filterByFirstName' -->&lt;!-- /WSLET -->
									</xsl:text>
								</b>
								</td>
								<td>
								<b>
									<xsl:text disable-output-escaping="yes">
										&lt;!-- WSLET CODE=PTString -->&lt;!-- PARAM NAME=RESOURCE_STRING VALUE='filterByLastName' -->&lt;!-- /WSLET -->
									</xsl:text>
								</b>
								</td>
								<td>
								<b>
									<xsl:text disable-output-escaping="yes">
										&lt;!-- WSLET CODE=PTString -->&lt;!-- PARAM NAME=RESOURCE_STRING VALUE='filterByUserId' -->&lt;!-- /WSLET -->
									</xsl:text>
								</b>
								</td>
								<td>
								<b>
									<xsl:text disable-output-escaping="yes">
										&lt;!-- WSLET CODE=PTString -->&lt;!-- PARAM NAME=RESOURCE_STRING VALUE='auditOperation' -->&lt;!-- /WSLET -->									
									</xsl:text>								
								</b>
								</td>
								<td>
								<b>
									<xsl:text disable-output-escaping="yes">
										&lt;!-- WSLET CODE=PTString -->&lt;!-- PARAM NAME=RESOURCE_STRING VALUE='auditDetails' -->&lt;!-- /WSLET -->
									</xsl:text>								
								</b>
								</td>
							</tr>
						</thead>

					<xsl:for-each select="admin-audit-log/entry">
						<tr>
							<td style="white-space: nowrap;">							
								<xsl:text disable-output-escaping="yes">
								 	&lt;!-- WSLET CODE=PTAdmin -->
								 		&lt;!-- PARAM NAME=FORMAT_AUDIT_DATE -->
								 		&lt;!-- PARAM NAME=AUDIT_DATE VALUE='</xsl:text><xsl:value-of select="date" /><xsl:text disable-output-escaping="yes">'-->
								 	&lt;!-- /WSLET -->
								</xsl:text>
							</td>
							<td>
								<xsl:value-of select="first-name" />
							</td>
							<td>
								<xsl:value-of select="last-name" />
							</td>
							<td>
								<xsl:value-of select="user-id" />
							</td>
							<td>
								<xsl:if test="operation = 'USER'">
									<xsl:text disable-output-escaping="yes">
										&lt;!-- WSLET CODE=PTString -->&lt;!-- PARAM NAME=RESOURCE_STRING VALUE='auditUserOpLbl' -->&lt;!-- /WSLET -->
									</xsl:text>	
								</xsl:if>
								<xsl:if test="operation = 'GROUP'">
									<xsl:text disable-output-escaping="yes">
										&lt;!-- WSLET CODE=PTString -->&lt;!-- PARAM NAME=RESOURCE_STRING VALUE='auditGroupOpLbl' -->&lt;!-- /WSLET -->
									</xsl:text>
								</xsl:if>
								<xsl:if test="operation = 'PACKAGE'">
									<xsl:text disable-output-escaping="yes">
										&lt;!-- WSLET CODE=PTString -->&lt;!-- PARAM NAME=RESOURCE_STRING VALUE='auditPackageOpLbl' -->&lt;!-- /WSLET -->
									</xsl:text>	
								</xsl:if>
								<xsl:if test="(operation = 'ACL') or (operation = 'ACL_ACTIVATION')">
									<xsl:text disable-output-escaping="yes">
										&lt;!-- WSLET CODE=PTString -->&lt;!-- PARAM NAME=RESOURCE_STRING VALUE='auditAclOpLbl' -->&lt;!-- /WSLET -->
									</xsl:text>	
								</xsl:if>
								<xsl:if test="operation = 'DATABASE'">
									<xsl:text disable-output-escaping="yes">
										&lt;!-- WSLET CODE=PTString -->&lt;!-- PARAM NAME=RESOURCE_STRING VALUE='auditDatabaseLbl' -->&lt;!-- /WSLET -->
									</xsl:text>	
								</xsl:if>
								<xsl:if test="operation = 'SERVER'">
									<xsl:text disable-output-escaping="yes">
										&lt;!-- WSLET CODE=PTString -->&lt;!-- PARAM NAME=RESOURCE_STRING VALUE='auditServerLbl' -->&lt;!-- /WSLET -->
									</xsl:text>	
								</xsl:if>
								<xsl:if test="operation = 'MIGRATE'">
									<xsl:text disable-output-escaping="yes">
										&lt;!-- WSLET CODE=PTString -->&lt;!-- PARAM NAME=RESOURCE_STRING VALUE='auditMigrateLbl' -->&lt;!-- /WSLET -->
									</xsl:text>	
								</xsl:if>
								<xsl:if test="operation = 'ROLES'">
									<xsl:text disable-output-escaping="yes">
										&lt;!-- WSLET CODE=PTString -->&lt;!-- PARAM NAME=RESOURCE_STRING VALUE='auditRolesLbl' -->&lt;!-- PARAM NAME=BUNDLE VALUE='52_patch' -->&lt;!-- /WSLET -->
									</xsl:text>	
								</xsl:if>
							</td>
							<td style="white-space: normal">
								<xsl:text disable-output-escaping="yes">
									&lt;!-- WSLET CODE=PTAdmin -->
									&lt;!-- PARAM NAME=FORMAT_AUDIT_DETAIL -->
									&lt;!-- PARAM NAME=AUDIT_DETAIL VALUE='</xsl:text><xsl:value-of select="details" /><xsl:text disable-output-escaping="yes">' -->
									&lt;!-- /WSLET -->
								</xsl:text>								
							</td>
						</tr>
					</xsl:for-each>
				</table>
				<form name="pt_form_load" action="NO_ACTION" class="hiddenForm">
					<input name="ACTION_FLAG" type="hidden" value="NO_ACTION"/>
					<input name="TEMPLATE_FLAG" type="hidden" value="NO_ACTION"/>
				
					<!-- PT Security Data -->
					<input name="role" type="hidden" value="NO_ACTION"/>
					<input name="token" type="hidden" value="NO_ACTION"/>
					<input name="formName" type="hidden" value="homePage"/>
				</form>
			</body>
		</html>
	</xsl:template>
</xsl:stylesheet>
