<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<!-- %full_filespec: quick_search_ui.jsp,7:ascii:W#2 % -->
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@ taglib prefix="change" uri="http://www.telelogic.com/change"%>
<html>
<head>
<title>${title}</title>

<style type="text/css">
	<change:wsletExpander>
		<!-- WSLET CODE=PTInclude -->
		<!-- PARAM NAME=styles/default.css -->
		<!-- PARAM NAME=styles/passwordPolicy.css -->
		<!-- PARAM NAME=styles/quick_search.css -->
		<!-- /WSLET -->
	</change:wsletExpander>
	
	body {
		/* IE hack to center the wrapper */
		text-align: center;
	}

	#wrapper {
		/* center a skinnier page */
		width: 48em;
		margin: 0 auto;
		text-align: left;
	}

	#results{
		margin: 4px;
	}
	
	#q {
		width: 100%
	}
	
	#banner {
		background: url(<change:urlCreator webResource='PTIMAGES'/>top_bg.png) repeat-x;
		text-align: left;
		margin: 0 0 1em 0;
		padding: 0;
	}
	
	#banner img {
		margin: 0;
	}
</style>


</head>
<body>

<div id="banner">
	<img src="<change:urlCreator webResource='PTIMAGES'/>top_logo.png" alt="Rational Change Logo">
</div>

<div id="wrapper">
	<span style="color: gray;">
		<change:resource bundle="52_patch" key="quickSearchPrompt"/>
	</span>

	<img src="<change:urlCreator webResource='PTIMAGES'/>spinningWait13px.gif" alt="wait" id="wait" style="visibility: hidden;">

	<table>
		<col width="999"><col width="1">
		<tr>
			<td>
				<input type="text" id="q" name="q" autocomplete="off">
			</td>
		</tr>
	</table>

	<div id="results" class="qs-menu" style="display: none;">
		<!-- Filled with ajax results -->
	</div>
</div>

<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dojo/dojo/dojo.js"></script>
<script type="text/javascript" src="<change:urlCreator webResource='JS'/>quick_search.js"></script>
<script type="text/javascript" src="<change:urlCreator webResource='JS'/>oslc.js"></script>

<script type="text/javascript">
	var $ = dojo.byId;
	

	dojo.addOnLoad(function() {
		
		var qs = new QuickSearch(
			'<c:url value="/quick_search.do"/>',
			'${token}',
			$('q'),
			{
				menuContainer: $('results'),
				onStartSearch: function() { $('wait').style.visibility = 'visible'; },
				onEndSearch: function() { $('wait').style.visibility = 'hidden'; },
				onSelect: function(crid, optionalSynopsis) {
					var url = oslc.sendSelect(crid, optionalSynopsis); 
					if (window.parent == window)
					{
						// No OSLC container, so redirect ourself.
						window.location.href = url;
					}
				}
			});

		$('q').focus();	
		qs.open();
	});
</script>
</body>
</html>
